# -*- coding: utf-8 -*-
###########################################################################
#
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
# eole@ac-dijon.fr
#
# librairie pour la ompilation des paquets Eole
#
###########################################################################

from eolepack.configserver import EOLEPACK_FILE, COMPIL_PATH, SVN_ORIG_PATH, DEBEMAIL, DEBFULLNAME, CLONE_DIR
import os
from os.path import join, isdir, isfile
from shutil import copyfile
from glob import glob
import subprocess
from eolepack import eolepackgit
from eolepack.errors import *

class Build:
    """actions de compilation"""
    def __init__(self, project, branch='master', distribution='', revision='', rep=''):
        """
        vars: variables des différents fichiers de config
        """
        self.project = project
        self.branch = branch
        self.distribution = distribution
        self.revision = revision
        self.rep = rep

    def insert_debchange(self, long_release):
        if not isfile('debian/changelog'):
            raise ChangelogNotFound
        environ = {}
        environ['DEBEMAIL'] = DEBEMAIL
        environ['DEBFULLNAME'] = DEBFULLNAME
        retcode = subprocess.call('cd %s && /usr/bin/git-dch -a -R --distrib="%s" -N %s' \
                % (join(CLONE_DIR, self.project), self.distribution, long_release), shell=True, env=environ)
        if retcode != 0:
            raise DebChangeError
        # commit du changelog
        eolepackgit.git_commit("## Nouveau paquet : %s (%s) %s ##"%(self.project, long_release, self.distribution), self.project)

    def debuild(self):
        """ options
        --git-export=<commit-id>
        --git-upstream-branch=branch_name
        --git-debian-branch=branch_name
        """
        options = ''
        if self.branch:
            options += '--git-upstream-branch=%s --git-debian-branch=%s' % (self.branch, self.branch)
        if self.revision:
            options += '--git-export=%s' % self.revision

        retcode = subprocess.call("cd %s && /usr/bin/git-buildpackage %s --git-tag \
                | tee -a ../rapport.txt" % (join(CLONE_DIR, self.rep or self.project), options), shell=True)
        print "retcode build : %s" % retcode
        if retcode != 0:
            raise BuildError
        if glob('../*.deb') == []:
            # aucun paquet généré
            raise BuildError

    #def sign_packages(self):
    #    os.system("""debsign -kBE7294AB *.changes""")

    #def commit_changelog(self, project, long_release, distribution):
    #    """
    #    commit du changelog
    #    """
    #    # commit des modifications dans git
    #    retcode = subprocess.call('echo "\n" | /usr/bin/git commit -a -m "" '
    #    os.system("rm -rf svn_deb")
    #    eolepackgit.commit("## Nouveau paquet : %s (%s) %s %s ##"%(project, long_release, distribution, self.depuis), clone_dir)
    #    os.chdir(olddir)

    def put_deb_repository(self, repository='eole'):
        """
        envoi des paquets sur le repository
        """
        print "envoi des paquets"
        os.system("""dput %s *.changes"""% (repository))

